from hombre.constants import CheckStatus
from hombre.constants import Feature
from hombre.constants import NUM_TRANSPORT_NODE_LIMIT
from hombre.constants import PrecheckPlugin
from hombre.constants import Url
from hombre.precheck.plugin_base import PluginBase
from hombre.utils import requests_wrapper


class PluginTransportNodes(PluginBase):
    id = PrecheckPlugin.TRANSPORT_NODES
    name = "feature.precheck.transportNodesName"
    desc = "feature.precheck.transportNodesDesc"
    feature = Feature.INTELLIGENCE

    def check(self):
        try:
            self.report_check_status(CheckStatus.INPROGRESS, "")
            # create request parameters
            print("Calling NSX manager to get total transport node count")
            json_response = requests_wrapper.egress_request(
                'GET', Url.Egress.GET_TRANSPORT_NODES)
            if json_response["result_count"] > NUM_TRANSPORT_NODE_LIMIT:
                self.report_check_status(
                    CheckStatus.WARNING,
                    "feature.precheck.transportNodesFailReason: {exceed_count}".format(
                        exceed_count=(NUM_TRANSPORT_NODE_LIMIT - int(json_response["result_count"]))))
            else:
                self.report_check_status(CheckStatus.SUCCESS, "feature.precheck.transportNodesPassReason")
        except Exception as e:
            self.report_check_status(
                CheckStatus.FAILED, "feature.precheck.nsxApiInvocationFailedReason")
            print(e)
            raise
