from hombre import constants
from hombre.constants import MONITOR_API_HOST, CLUSTER_API_HOST, Url


def mock_platform_type_adv_pass(method, url, data=None, headers=None):
    if method == "GET":
        if url == Url.InCluster.GET_FEATURE_INTEL_CONFIG.format(
                service_host=CLUSTER_API_HOST, service_port="443"):
            return {
                "deployment_chart_name": "nsxi-chart"
            }
        elif url == Url.InCluster.GET_PLATFORM_STATUS.format(
                service_host=MONITOR_API_HOST, service_port="443"):
            return {
                "form_factor": constants.PlatformFormFactor.ADVANCED
            }
    elif method == "POST":
        if url == Url.InCluster.POST_REPORT_PRECHECK:
            return {}


def mock_platform_type_adv_fail(method, url, data=None, headers=None):
    if method == "GET":
        if url == Url.InCluster.GET_FEATURE_INTEL_CONFIG.format(
                service_host=CLUSTER_API_HOST, service_port="443"):
            return {
                "deployment_chart_name": "nsxi-chart"
            }
        elif url == Url.InCluster.GET_PLATFORM_STATUS.format(
                service_host=MONITOR_API_HOST, service_port="443"):
            return {
                "form_factor": constants.PlatformFormFactor.EVALUATION
            }
    elif method == "POST":
        if url == Url.InCluster.POST_REPORT_PRECHECK:
            return {}


def mock_egress_transport_node_pass(method, url, data=None, headers=None):
    if method == "GET" and url == Url.Egress.GET_TRANSPORT_NODES:
        return {
            "result_count": 250
        }


def mock_egress_transport_node_fail(method, url, data=None, headers=None):
    if method == "GET" and url == Url.Egress.GET_TRANSPORT_NODES:
        return {
            "result_count": 251
        }


def mock_incluster_transport_node(method, url, data=None, headers=None):
    if method == "POST" and url == Url.InCluster.POST_REPORT_PRECHECK:
        return {}
